{$N+,E+}
{****************************************************************************
 *           } Unit UData;{ (c) 1999 Michal Cihar                           *
 ****************************************************************************}
interface
const MaxDelka    =239; {delka vyrazu - 4 radky po 60 znacich}
      MaxFunkci   =46; {pocet definovanych funkci}
      MinPamet    =64*1024; {64 kB pameti by melo zustat volne}
      AbsMinPamet =12*1024; {12 kB je opravdu nutne minimum!!!}

      {casto pouzivana cisla:}
      Pi_pul      :extended=pi/2;
      pi_2        :extended=pi*2;


type
     TCislo      = extended; {format cisla}
     Retezec     = string[MaxDelka]; {vstupni retezec}
     TFunkceDef  = procedure (var Vysledek : TCislo);
     TFunkce     = Record
                         Jmeno:string;
                         Proved:Tfunkcedef;
                   end; {definovane funkce}
     TUhlovaMira = (deg,rad,grad); {v jake uhlove mire pocitat}

const
     {prace s chybami:}
     ZadnaChyba          = 0;
     SpatnyExponent      = 1;
     ChybiExponent       = 2;
     NeniPromenna        = 3;
     NeniKonstanta       = 4;
     NeniCislo           = 5;
     ChybiKonecZavorky   = 6;
     ChybiZacatekZavorky = 7;
     ChybiCarka          = 8;
     DeleniNulou         = 9;
     SpatnaMocnina       =10;
     SpatnyLog           =11;
     SpatnyZaklLog       =12;
     SpatnyTan           =13;
     SpatnaOdmoc         =14;
     SpatnyCoTan         =15;
     SpatnyArcSin        =16;
     SpatnyArcCos        =17;
     SpatneJmeno         =18;
     ChybaVPameti        =19;
     ChybiHodnota        =20;
     SpatnyFaktorial     =21;
     SpatnyCoTanH        =22;
     SpatnyArgCosh       =23;
     SpatnyArgTanh       =24;
     SpatnyArgCoTanh     =25;
     SpatnYKombinace     =26;
     SpatnyVariace       =27;
     NeocekavanyKonec    =28;
     Preteceni           =29;

     {kdo ma zajem o presnejsi cisla:}
     pi_125='3.1415926535897932384626433832795028841971693993751058209749445'
            +'923078164062862089986280348253421170679821480865132823066470938';
     e_125= '2.7182818284590452353602874713526624977572470936999595749669676'
           + '277240766303535475945713821785251664274274663919320030599218174';

     UhlovaMira:TUhlovaMira=deg; {v jake uhlove mire jsou zadavana cisla}

     oddelovace:set of char=[' ','\',';','*','/','^','+','=','-','%','(',')',',','!'];
     {cim jsou oddelena "slova" v zadavanem retezci}
     operatory:set of char=['\','*','/','^','+','-','%','(','!'];
     {operatory}

var FunkceData:array[1..maxFunkci] of TFunkce; {z tohoto pole se zjistuje
                                                funkce, ktera se provede}
    chybacislo,ChybaNa:byte; {cislo chyby, pozice chyby}
    chybastr:string; {retezec, ktery zpusobil chybu}

function chyba2str:string; {popis chyby}
function je_funkce(const s:string):boolean; {zjisteni, jestli je s funkce}
function zRad(co:tcislo):tcislo; {prevod z radu na aktualni uhlovou miru}
function NaRad(co:tcislo):tcislo; {prevod z aktualni uhlove miry na rady}
function pamet_free:byte; {jestli je dostatek pameti (konstanty MinPamet a
                           AbsMinPamet)}

implementation

function pamet_free:byte;
begin;
if (memavail>minpamet) then pamet_free:=0 else
if (memavail>Absminpamet) then pamet_free:=1 else
                               pamet_free:=2;
end;

function chyba2str:string;
begin;
case chybacislo of
     ZadnaChyba          :chyba2str:='Zadna chyba'+chybastr;
     SpatnyExponent      :chyba2str:='Chybny exponent: '+chybastr;
     ChybiExponent       :chyba2str:='Chybi exponent'+chybastr;
     NeniPromenna        :chyba2str:=''+chybastr+' neni promenna';
     NeniKonstanta       :chyba2str:=''+chybastr+' neni konstanta';
     NeniCislo           :chyba2str:=''+chybastr+' neni cislo';
     ChybiKonecZavorky   :chyba2str:='Chybi konec zavorky'+chybastr;
     ChybiZacatekZavorky :chyba2str:='Chybi zacatek zavorky'+chybastr;
     ChybiCarka          :chyba2str:='Chybi carka'+chybastr;
     DeleniNulou         :chyba2str:='Deleni nulou'+chybastr;
     SpatnaMocnina       :chyba2str:='Chybny parametr mocniny'+chybastr;
     SpatnyLog           :chyba2str:='Chybny parametr logaritmu: '+chybastr;
     SpatnyZaklLog       :chyba2str:='Chybny zaklad logaritmu: '+chybastr;
     SpatnyTan           :chyba2str:='Chybny parametr tangens: '+chybastr;
     SpatnaOdmoc         :chyba2str:='Chybny parametr odmocniny: '+chybastr;
     SpatnyCoTan         :chyba2str:='Chybny parametr cotangens: '+chybastr;
     SpatnyArcSin        :chyba2str:='Chybny parametr arcus sinus: '+chybastr;
     SpatnyArcCos        :chyba2str:='Chybny parametr arcus cosinus: '+chybastr;
     SpatneJmeno         :chyba2str:='Spatne jmeno funkce/promenne/konstany :'+chybastr;
     ChybaVPameti        :chyba2str:='Chyba v pameti'+chybastr;
     ChybiHodnota        :chyba2str:='Chybi hodnota'+chybastr;
     SpatnyFaktorial     :chyba2str:='Chybny parametr faktorialu: '+chybastr;
     SpatnyCoTanH        :chyba2str:='Chybny parametr hyp cotangens: '+chybastr;
     SpatnyArgCosh       :chyba2str:='Chybny parametr hyp argcosinus: '+chybastr;
     SpatnyArgTanh       :chyba2str:='Chybny parametr hyp argtangens: '+chybastr;
     SpatnyArgCoTanh     :chyba2str:='Chybny parametr hyp argcotangens: '+chybastr;
     SpatnYKombinace     :chyba2str:='Chybny parametr kombinace: '+chybastr;
     SpatnyVariace       :chyba2str:='Chybny parametr variace: '+chybastr;
     NeocekavanyKonec    :chyba2str:='Neocekavany konec vyrazu'+chybastr;
     Preteceni           :chyba2str:='Prilis velke cislo - doslo k preteceni velikosti cisla'+chybastr;
     else chyba2str:='Neznama chyba: '+chybastr;
     end;
end;

function je_funkce(const s:string):boolean;
var b:byte;
    vysl:boolean;
begin;
vysl:=false;
for b:=1 to maxfunkci do
    if funkcedata[b].jmeno=s then
    begin;
      vysl:=true;
      break;
    end;
je_funkce:=vysl;
end;

function zRad(co:tcislo):tcislo;
begin;
case UhlovaMira of deg:zRad:=(co/pi)*180;
                   rad:zRad:=co;
                   grad:zRad:=(co/pi)*200;
                   end;
end;

function NaRad(co:tcislo):tcislo;
begin;
case UhlovaMira of deg:naRad:=(co/180)*pi;
                   rad:naRad:=co;
                   grad:naRad:=(co/200)*pi;
                   end;
end;

begin;
end.