{$N+,E+}
{****************************************************************************
 *           } Unit UPamet;{ (c) 1999 Michal Cihar                          *
 ****************************************************************************}
interface
uses udata,strfunc;
const
      {chybove konstanty}
      ZadnaChyba       =0;
      PromenaNeexistuje=1;
      SpatneJmeno      =2;
      MaloPameti       =3;
      JeKonstanta      =4;
      JeFunkce         =5;
      MocDlouheJmeno   =6;

      {maximalni delka nazvu promenne}
      maxpromdelka     =40;

{Prace s pameti}
function nova_promenna(const s:string;const hodn:TCislo):longint; {zalozi
                                                           novou promennou}
function do_pameti(const s:string;const hodn:TCislo):longint; {ulozi do
                                                              pameti}
function z_pameti(const s:string;var b:boolean):TCislo; {vybere z pameti}
function je_promenna(const s:string):boolean; {zjisti jestli je promenna}
function Zrus_Promennou(const s:string):boolean; {zrusi promennou}
function jmeno_prom(const n:longint):string; {vrati jmeno n-te promenne
                                             (pro vypis)}
function ZmenaPameti:boolean; {vraci jestli byla zmena pameti}
function poslednizmena:string; {posledni zmena pameti}
procedure initpamet; {inicializace}
function pametpocet:longint; {pocet promennych}
function promvel:longint; {velikost 1 promenne v pameti}
procedure zruspamet; {zrusi pamet}

{soubory}
function nahrajpamet(jmeno:string;psat:boolean):byte;
function ulozpamet(jmeno:string;psat:boolean):byte;

{konstanty}
function nova_konst(const s,info:string;const hodn:TCislo):longint; {zalozi
                                                           novou konstantu}
function z_konst(const s:string;var b:boolean):TCislo; {vybere z konstant}
function info_konst(const s:string;var b:boolean):string; {informace o
                                                          konstante}
function je_konst(const s:string):boolean; {vrati jestli je konstanta}
function zmen_ans(const hodn:TCislo):boolean; {zmeni ANS}
function jmeno_konst(const n:longint):string; {vraci jemeno n-te konstanty}
procedure initkonst; {inicializace konstant}
function konstpocet:longint; {pocet konstant}
function konstvel:longint; {velikost 1 konstanty v pameti}

{chyby}
function ChybaPameti:byte; {vrati cilo chyby - vymaze ho}
function ChybaPameti_:byte; {vrati cilo chyby - nevymaze ho}

implementation
var
  oldexit : pointer;

type
     PPromenna=^TPromenna;
     TPromenna=record
                jmeno:string[maxpromdelka];
                hodnota:extended;
                predchozi,dalsi:PPromenna;
                end;
     LPromenna=record
                Prvni,Posledni:PPromenna;
                Pocet:longint;
               end;
type
     Pkonst=^Tkonst;
     Tkonst=record
                jmeno:string[20];
                info:string[50];
                hodnota:extended;
                predchozi,dalsi:Pkonst;
                end;
     Lkonst=record
                Prvni,Posledni:Pkonst;
                Pocet:longint;
               end;
var
   pametchyba:byte;
   Pamet:LPromenna;
   Konstanty:Lkonst;
   pametzmena:boolean;
   PosledniPromenna:string;

{velikost promenne}
function promvel:longint;
begin;
promvel:=sizeof(Tpromenna);
end;

{velikost konstanty}
function konstvel:longint;
begin;
konstvel:=sizeof(Tkonst);
end;

{pocet promennych}
function pametpocet:longint;
begin;
pametpocet:=pamet.pocet;
end;

{pocet konstant}
function konstpocet:longint;
begin;
konstpocet:=konstanty.pocet;
end;

{posledni zmena v pameti}
function poslednizmena:string;
begin;
poslednizmena:=PosledniPromenna;
end;

{inicializace pameti}
procedure initpamet;
begin;
with pamet do
begin;
 Prvni:=nil;
 Posledni:=nil;
 Pocet:=0;
end;
pametchyba:=ZadnaChyba;
end;

{inicializace konstant}
procedure initkonst;
begin;
with konstanty do
begin;
 Prvni:=nil;
 Posledni:=nil;
 Pocet:=0;
end;
pametchyba:=ZadnaChyba;
end;

{byla zmena v pameti - dalsi informace ziskat funkci poslednizmena}
function ZmenaPameti:boolean;
begin;
zmenapameti:=pametzmena;
pametzmena:=false;
end;

{byla chyba v pameti}
function ChybaPameti:byte;
begin;
chybapameti:=pametchyba;
pametchyba:=0;
end;

{totez jako predchozi, ale nenuluje interni promennou}
function ChybaPameti_:byte;
begin;
chybapameti_:=pametchyba;
end;

{zmeni hodnotu promenne - jmeno s a hodnota cislo}
function zmen_promennou(const s:string;const cislo:TCislo):boolean;
var akt:ppromenna;
begin;
akt:=pamet.prvni;
while navelka(s)<>akt^.jmeno do if akt^.dalsi<>nil then akt:=akt^.dalsi else break;
if navelka(s)=akt^.jmeno then
begin;
   akt^.hodnota:=cislo;
   zmen_promennou:=true;
   pametzmena:=true;
   PosledniPromenna:='Zmenena promenna '+s+' na hodnotu '+cislo2str(cislo);
   pametchyba:=zadnachyba;
end else zmen_promennou:=false;
end;

{vrati hodnotu promenne se jmenem s}
function z_pameti(const s:string;var b:boolean):TCislo;
var akt:ppromenna;
begin;
akt:=pamet.prvni;
while navelka(s)<>akt^.jmeno do if akt^.dalsi<>nil then akt:=akt^.dalsi else break;
if navelka(s)=akt^.jmeno then
   begin;
     z_pameti:=akt^.hodnota;
     b:=true;
     pametchyba:=zadnachyba;
   end
   else begin;b:=false;pametchyba:=PromenaNeexistuje;end;
end;

{ulozi pamet do souboru jmeno}
function ulozpamet(jmeno:string;psat:boolean):byte;
var f:file;
    result:word;
    i:longint;
    temp:ppromenna;
begin;
assign(f,jmeno);
{$i-}
rewrite(f,1);
if ioresult<> 0 then begin;ulozpamet:=1;exit;end;
{$i+}
blockwrite(f,pamet,sizeof(lpromenna),result);
if result<> sizeof(lpromenna) then begin;ulozpamet:=2;exit;end;
temp:=pamet.prvni;
for i:=1 to pamet.pocet do
begin;
  blockwrite(f,temp^,sizeof(tpromenna),result);
  if psat then write(((i*100)/pamet.pocet):5:2,' %'#13);
  if result<> sizeof(tpromenna) then begin;ulozpamet:=3;exit;end;
  temp:=temp^.dalsi;
  if temp=nil then break;
end;
close(f);
ulozpamet:=0;
end;

{nahraje pamet ze souboru jmeno}
function nahrajpamet(jmeno:string;psat:boolean):byte;
var f:file;
    result:word;
    i:longint;
    temp:ppromenna;
    templ:lpromenna;
begin;
assign(f,jmeno);
{$i-}
reset(f,1);
if ioresult<> 0 then begin;
                                     pametzmena:=false;
nahrajpamet:=1;exit;end;
{$i+}
blockread(f,templ,sizeof(lpromenna),result);
if result<> sizeof(lpromenna) then begin;
                                     pametzmena:=false;
nahrajpamet:=2;exit;end;
if templ.pocet<1 then begin;
                                     pametzmena:=false;
nahrajpamet:=4;exit;end;
new(temp);
for i:=1 to templ.pocet do
begin;
  blockread(f,temp^,sizeof(tpromenna),result);
  if psat then write(((i*100)/templ.pocet):5:2,' %'#13);
  if result<> sizeof(tpromenna) then begin;
                                     pametzmena:=false;
                                     nahrajpamet:=3;exit;end;
  do_pameti(temp^.jmeno,temp^.hodnota);
  if pametchyba<>0 then begin;
                        nahrajpamet:=5;
                        pametzmena:=false;
                        exit;end;
end;
close(f);
nahrajpamet:=0;
   pametzmena:=true;
   PosledniPromenna:='Nahrany promenne ze soubory '+jmeno;
   pametchyba:=zadnachyba;
end;

{vrati jmeno n-te promenne - pro vypis promennych}
function jmeno_prom(const n:longint):string;
var akt:ppromenna;
    x:longint;
begin;
if n<=pamet.pocet then
begin;
akt:=pamet.prvni;
x:=1;
while x<n do begin;akt:=akt^.dalsi;inc(x);end;
jmeno_prom:=akt^.jmeno;
end else jmeno_prom:='';
end;

{vrati jmeno n-te konstanty - pro vypis konstant}
function jmeno_konst(const n:longint):string;
var akt:pkonst;
    x:longint;
begin;
if n<=konstanty.pocet then
begin;
akt:=konstanty.prvni;
x:=1;
while x<n do begin;akt:=akt^.dalsi;inc(x);end;
jmeno_konst:=akt^.jmeno;
end else jmeno_konst:='';
end;

{vrati hodnotu konstanty se jmenem s}
function z_konst(const s:string;var b:boolean):TCislo;
var akt:pkonst;
begin;
akt:=konstanty.prvni;
while navelka(s)<>akt^.jmeno do if akt^.dalsi<>nil then akt:=akt^.dalsi else break;
if navelka(s)=akt^.jmeno then
   begin;
     z_konst:=akt^.hodnota;
     b:=true;
     pametchyba:=zadnachyba;
   end
   else begin;b:=false;pametchyba:=PromenaNeexistuje;end;
end;

{vrati informace o konstante se jmenem s}
function info_konst(const s:string;var b:boolean):string;
var akt:pkonst;
begin;
akt:=konstanty.prvni;
while navelka(s)<>akt^.jmeno do if akt^.dalsi<>nil then akt:=akt^.dalsi else break;
if navelka(s)=akt^.jmeno then
   begin;
     info_konst:=akt^.info;
     b:=true;
     pametchyba:=zadnachyba;
   end
   else begin;b:=false;pametchyba:=PromenaNeexistuje;end;
end;

{zjisti jestli je promenna se jmenem s v pameti}
function Je_Promenna(const s:string):boolean;
var akt:ppromenna;
begin;
if pamet.prvni<>nil then
begin;
akt:=pamet.prvni;
while akt^.dalsi<>nil do
      if navelka(s)=akt^.jmeno then break
                               else akt:=akt^.dalsi;
if navelka(s)=akt^.jmeno then je_promenna:=true else je_promenna:=false;
end else je_promenna:=false;
end;

{zjisti jestli existuje konsanta se jmenem s v pameti}
function Je_Konst(const s:string):boolean;
var akt:pkonst;
begin;
if konstanty.prvni<>nil then
begin;
akt:=konstanty.prvni;
while akt^.dalsi<>nil do
      if navelka(s)=akt^.jmeno then break
                               else akt:=akt^.dalsi;
if navelka(s)=akt^.jmeno then je_konst:=true else je_konst:=false;
end else je_konst:=false;
end;

{zrusi promennou se jmenem s}
function Zrus_Promennou(const s:string):boolean;
var akt:ppromenna;
begin;
akt:=pamet.prvni;
while navelka(s)<>akt^.jmeno do if akt^.dalsi<>nil then akt:=akt^.dalsi else break;
if navelka(s)=akt^.jmeno then
begin;
  if akt^.predchozi<>nil then (akt^.predchozi)^.dalsi:=akt^.dalsi
                         else pamet.prvni:=akt^.dalsi;
  if akt^.dalsi<>nil then (akt^.dalsi)^.predchozi:=akt^.predchozi
                     else pamet.posledni:=akt^.predchozi;
  dispose(akt);
  Zrus_Promennou:=true;
  pametzmena:=true;
  pamet.pocet:=pamet.pocet-1;
  PosledniPromenna:='Zrusena promenna '+s;
  pametchyba:=zadnachyba;
end else begin;Zrus_Promennou:=false;pametchyba:=PromenaNeexistuje;end;
end;

{zrusi konstantu se jmenem s}
function Zrus_Konst(const s:string):boolean;
var akt:pkonst;
begin;
akt:=konstanty.prvni;
while navelka(s)<>akt^.jmeno do if akt^.dalsi<>nil then akt:=akt^.dalsi else break;
if navelka(s)=akt^.jmeno then
begin;
  if akt^.predchozi<>nil then (akt^.predchozi)^.dalsi:=akt^.dalsi
                         else konstanty.prvni:=akt^.dalsi;
  if akt^.dalsi<>nil then (akt^.dalsi)^.predchozi:=akt^.predchozi
                     else konstanty.posledni:=akt^.predchozi;
  dispose(akt);
  Zrus_konst:=true;
  pametzmena:=true;
  konstanty.pocet:=konstanty.pocet-1;
  PosledniPromenna:='Zrusena konstanta '+s;
  pametchyba:=zadnachyba;
end else begin;Zrus_konst:=false;pametchyba:=PromenaNeexistuje;end;
end;

{ulozi do pameti promennou se jmenem s - pokud neexistuje zalozi novou,
                                         jinak zmeni hodnotu}
function do_pameti(const s:string;const hodn:TCislo):longint;
var prom:PPromenna;
begin;
if je_promenna(s) then
begin;
  zmen_promennou(s,hodn);
  do_pameti:=pamet.pocet;
end else
if not(je_konst(s)) then
if not(je_funkce(s)){pos(navelka(s),znamefunkce)=0} then
do_pameti:=nova_promenna(s,hodn)
else pametchyba:=jefunkce
else pametchyba:=jekonstanta;
end;

{zavede novou promennou se jmenem s}
function nova_promenna(const s:string;const hodn:TCislo):longint;
var prom:PPromenna;
begin;
if length(s)<=maxpromdelka then
begin;
 if upcase(s[1]) in ['A'..'Z','_'] then
  begin;
  if MaxAvail>=promvel then
   begin;
    new(prom);
    if prom=nil then
     begin;
      nova_promenna:=pamet.pocet;
      pametchyba:=MaloPameti;
     end else
     begin;
      prom^.jmeno:=navelka(s);
      prom^.hodnota:=hodn;
      if pamet.prvni=nil then
                          begin;
                            pamet.prvni:=prom;
                            pamet.posledni:=prom;
                            prom^.dalsi:=nil;
                            prom^.predchozi:=nil;
                          end
                         else
                          begin;
                            prom^.predchozi:=pamet.posledni;
                            (pamet.posledni)^.dalsi:=prom;
                            pamet.posledni:=prom;
                            prom^.dalsi:=nil;
                          end;
      pamet.pocet:=pamet.pocet+1;
      nova_promenna:=pamet.pocet;
      PosledniPromenna:='Nova promenna '+s+'='+Cislo2Str(hodn);
      pametzmena:=true;
      pametchyba:=zadnachyba;
     end;
   end else
   begin;
     nova_promenna:=pamet.pocet;
     pametchyba:=MaloPameti;
   end;
  end else
  begin;
   pametchyba:=SpatneJmeno;
   nova_promenna:=pamet.pocet;
  end;
 end else
 begin;
   pametchyba:=MocDlouheJmeno;
   nova_promenna:=pamet.pocet;
 end;
end;

{zavede novou konstantu se jmenem s}
function nova_konst(const s,info:string;const hodn:TCislo):longint;
var prom:Pkonst;
begin;
if upcase(s[1]) in ['A'..'Z','_'] then
begin;
new(prom);
if prom=nil then
begin;
nova_konst:=konstanty.pocet;
pametchyba:=MaloPameti;
end else
begin;
prom^.jmeno:=navelka(s);
prom^.info:=info;
prom^.hodnota:=hodn;
if konstanty.prvni=nil then
                    begin;
                      konstanty.prvni:=prom;
                      konstanty.posledni:=prom;
                      prom^.dalsi:=nil;
                      prom^.predchozi:=nil;
                    end
                   else
                    begin;
                      (konstanty.posledni)^.dalsi:=prom;
                      konstanty.posledni:=prom;
                      prom^.dalsi:=nil;
                      prom^.predchozi:=nil;
                    end;
konstanty.pocet:=konstanty.pocet+1;
nova_konst:=konstanty.pocet;
PosledniPromenna:='Nova promenna '+s+'='+Cislo2Str(hodn);
pametzmena:=true;
pametchyba:=zadnachyba;
end;
end else
begin;
pametchyba:=SpatneJmeno;
nova_konst:=konstanty.pocet;
end;
end;

{zmeni hodnotu konstnty ANS - hodnota posledniho vypoctu}
function zmen_ans(const hodn:TCislo):boolean;
var akt:pkonst;
begin;
akt:=konstanty.prvni;
while 'ANS'<>akt^.jmeno do if akt^.dalsi<>nil then akt:=akt^.dalsi else break;
if 'ANS'=akt^.jmeno then
begin;
   akt^.hodnota:=hodn;
   zmen_ans:=true;
end else zmen_ans:=false;
end;

{zrusi pamet}
procedure zruspamet;
begin;
while pamet.pocet>0 do
begin;
zrus_promennou(pamet.prvni^.jmeno);
end;
end;

{zrusi konstanty}
procedure zruskonst;
begin;
while konstanty.pocet>0 do
begin;
zrus_konst(konstanty.prvni^.jmeno);
end;
end;

{procedura uvolnujici pamet pri ukonceni programu}
procedure exit_upamet;far;
begin
  exitproc := oldexit;
  zruspamet;
  zruskonst;
end;

begin;
{nastavime uvolneni pameti pri ukonceni programu:}
  oldexit  := exitproc;
  exitproc := @exit_upamet;
initpamet;
initkonst;
{1}
nova_konst('ans','Vysledek posledniho vypoctu',0.0);
nova_konst('e','Eulerovo cislo',{2.71828182845904524}exp(1));
nova_konst('pi','Ludolfovo cislo',{3.14159265358979324}pi);
nova_konst('_mp','Klidova hmotnost protonu [kg]',1.6726231e-27);
{5}
nova_konst('_f','Faradayova konstanta [C/mol]',96485.309);
nova_konst('_A0','Bohruv polomer [m]',5.29177249e-11);
nova_konst('_c','Rychlost svetla ve vakuu [m/s]',299792458);
nova_konst('_h','Plankova konstanta [J*s]',66.6260755e-34);
nova_konst('_gk','Gravitacni konstanta [N*m*m/kg*kg]',6.67259e-11);
{10}
nova_konst('_e','Elementarni naboj [C]',1.60217733e-19);
nova_konst('_me','Klidova hmotnost elektronu [kg]',9.1093897e-31);
nova_konst('_u','?Eng: Atomic mass unit [kg]',1.6605402e-27);
nova_konst('_Na','Avogadrova konstanta [1/mol]',6.0221367e+23);
nova_konst('_k','Boltzmannova konstanta [J/K]',1.380658e-23);
{15}
nova_konst('_g','Gravitacni zrychleni [m/s*s]',9.80665);
nova_konst('_r','?Eng: Molar gas constant [J/mol*k]',8.314510);
nova_konst('_e0','Permitivita vakua [F/m]',8.8541878176204e-12);
nova_konst('_u0','Permeabilita vakua [H/m]',1.2566370614359e-6);
nova_konst('_uB','Bohruv magneton [A/m*m]',9.2740154e-24);
{20}
nova_konst('_hk','Konvertovana (Converted) Plankova konstanta [J*s]',1.05457266e-34);
nova_konst('_mn','Klidova hmotnost neutronu [kg]',1.6749286e-27);
nova_konst('_R8','Rydbergova konstanta [1/m]',10973731.53);
nova_konst('_o','Stefan-Boltzmannova konstanta [W/m*m*k*k*k*k]',5.67051e-08);
nova_konst('Zetta','Prepona [Z]',1e21);
{25}
nova_konst('Exa','Prepona [E]',1e18);
nova_konst('peta','Prepona [P]',1e15);
nova_konst('tera','Prepona [T]',1e12);
nova_konst('giga','Prepona [G]',1e9);
nova_konst('Mega','Prepona [M]',1e6);
{30}
nova_konst('kilo','Prepona [k]',1e3);
nova_konst('hecta','Prepona [h]',1e2);
nova_konst('deca','Prepona [da]',1e1);
nova_konst('deci','Prepona [d]',1e-1);
nova_konst('centi','Prepona [c]',1e-2);
{35}
nova_konst('mili','Prepona [m]',1e-3);
nova_konst('micro','Prepona [u]',1e-6);
nova_konst('nano','Prepona [n]',1e-9);
nova_konst('piko','Prepona [p]',1e-12);
nova_konst('femto','Prepona [f]',1e-15);
{40}
nova_konst('atto','Prepona [a]',1e-18);
nova_konst('zepto','Prepona [z]',1e-21);
nova_konst('yokto','Prepona [y]',1e-24);

pametchyba:=0;
pametzmena:=false;
PosledniPromenna:='';
end.